function A=recover_qs(p,q,a,g,h,b,d)

% Computes matrix A from quasiseparable generators:
% - lower generators p,q,a
% - upper generators g,h,b
% - diagonal entries d.
%
% Warning: no check for size consistency.

N=length(d);
[~,rL]=size(p);
[rU,~]=size(h);

% Initialize A and fill in main diagonal. 
A=diag(d);

% Fill in lower triangular part.

for j=2:N
    x=p(j,:);
    for k=j-1:-1:2
        A(j,k)=x*q(:,k);
        x=x*a(:,:,k);
    end
    A(j,1)=x*q(:,1);
end

% Fill in upper triangular part.

for j=1:N-1
    x=g(j,:);
    for k=j+1:N-1
        A(j,k)=x*h(:,k);
        x=x*b(:,:,k);
    end
    A(j,N)=x*h(:,N);
end

end